#delimit;

/****************************************************************
***                 hier folgt der uebliche Dateikopf                   ***
****************************************************************
* Workspace bereitstellen, Operationspeiher erhoehen und
* Arbeitsverzeichnis wechseln.  Danach log-datei erstellen.
****************************************************************/

clear;    set mem 20m;    cd u:\ue4;
cap log close;  log using uebung4, text replace;


/****************************************************************
***                               A u f g a b e   1                                 ***
****************************************************************/

use mroz; save aufgabe1, replace;

probit inlf nwifeinc educ exper expersq age kidslt6 kidsge6;

***     Hosmer-Lemeshow Test fuer Anpassungsguete     ***;

lfit, group(10);
lfit, group(10) table;

save aufgabe1, replace;  clear;

/****************************************************************
***                               A u f g a b e   2                                 ***
****************************************************************/

use moodys; save aufgabe2, replace;

tab rating;

gen rating_k=1;
replace rating_k=2 if rating==3;
replace rating_k=3 if rating==4;
replace rating_k=4 if rating>=5;

tab rating_k;


*** a)  Schaetzung eines geordneten Modells;

ologit rating_k ekav avnetrev cffk netincnetrev netincav;
mfx compute, predict(outcome(1));

oprobit rating_k ekav avnetrev cffk netincnetrev netincav;
mfx compute, predict(outcome(1));


*** b)  Parzielle Effekte;

oprobit rating_k ekav avnetrev cffk netincnetrev netincav;


* - Parzielle Effekt fuer P(j=2), Durchschnittcharakteristiken der Gesamtstichprobe;
mfx compute, predict(outcome(2));


* - Parzielle Effekt fuer P(j=2), Durchschnittcharakteristiken der Teilstichprobe j=3;
mfx compute if rating_k==3, predict(outcome(2)) force;

sum netincnetrev if rating_k==2;
sum netincnetrev if rating_k==3;

/* - Parzielle Effekt fuer P(j=2) eines "j=3"-Unternehmens, das seine Jahresueberschuss/Umsatz
**  Index zum Niveau eines durchschnittlichen "j=2"-Unternehmens erhoeht                               */

mfx compute if rating_k==3, predict(outcome(2)) at(netincnetrev=0.136) force;


***  c)  Beispiel LR und Wald Tests;

* LRT;

oprobit rating_k ekav avnetrev cffk netincnetrev netincav;
gen ll_nr=e(ll);

gen beide_gleich=netincnetrev+netincav;

oprobit rating_k ekav avnetrev cffk beide_gleich;
gen ll_r=e(ll);

gen lrt=-2*(ll_r-ll_nr);   gen p_wert=chi2tail(1,lrt);
sum lrt p_wert;


* Wald-Test;

oprobit rating_k ekav avnetrev cffk netincnetrev netincav;
test netincnetrev=netincav;

save aufgabe2, replace;


log close;
